# Informatik
Unterlagen zu Informatik Vorlesungen der TU Ilmenau
> Kein Mensch kann Wissen besitzen. Wissen ist frei und muss weitergegeben werden

- [Algorithmen und Datenstrukturen](Algorithmen%20und%20Datenstrukturen.md)
- [Automaten, Sprachen und Komplexität](Automaten,%20Sprachen%20und%20Komplexität.md)
  - [Flashcards - Karteikarten für Definitionen](Automaten,%20Sprachen%20und%20Komplexität%20-%20Flashcards.pdf)
  - [Mind Map](Automaten,%20Sprachen%20und%20Komplexität%20-%20MindMap.pdf)
- [Betriebssysteme](Betriebssysteme.md)
  - [Flashcards/Karteikarten](Betriebssysteme%20-%20Flashcards.pdf)
  - [Cheatsheet](Betriebssysteme%20-%20Cheatsheet.pdf)
  - [Fragenkatalog](Betriebssysteme%20-%20Fragen.md)
- [Computergrafik](Computergrafik.md)
  - [Computergrafik Cheatsheet](Computergrafik%20-%20Cheatsheet.pdf) (work in progress)
- [Datenbanksysteme](Datenbanksysteme.md)
  - [Fragenkatalog](Datenbanksysteme%20-%20Fragen.md)
  - [Cheatsheet](Datenbanksysteme%20-%20Cheatsheet.pdf)
- [Einführung in die Medizinische Informatik](Einführung%20in%20die%20Medizinische%20Informatik.md)
- [Grundlagen und diskrete Strukturen](Grundlagen%20und%20Diskrete%20Strukturen.md)
  - [GudS - Cheatsheet](Grundlagen%20und%20Diskrete%20Strukturen%20-%20Cheatsheet.pdf)
  - [GudS - Short Paper](Grundlagen%20und%20Diskrete%20Strukturen%20-%20short.pdf)
- [Neurobiologische Informationsverarbeitung](Neurobiologische%20Informationsverarbeitung.md)
- [Neuroinformatik](Neuroinformatik.md) (letzte 2 Kapitel fehlen)
- [Programmierparadigmen](Programmierparadigmen.md)
- [Rechnerarchitekturen 1](Rechnerarchitekturen%201.md)
  - [Praktikum A1](Rechnerarchitekturen%201%20-%20Praktikum%20A1.pdf)
  - [Praktikum A2](Rechnerarchitekturen%201%20-%20Praktikum%20A2.pdf)
- [Rechnerarchitekturen 2](Rechnerarchitekturen%202.md)
- [Softwaretechnik](Softwaretechnik.md)
  - [Zusammenfassung](Softwaretechnik%20-%20Cheatsheet.pdf)
  - [Seminar](Softwaretechnik%20-%20Seminar.pdf)
  - [Beispiel Flowchart](Softwaretechnik%20Flowchart.tex)
- [Stochastik](Stochastik.md)
  - [Stochastik Cheatsheet](Stochastik%20-%20Cheatsheet.pdf)
- [Telematik 1](Telematik%201.md)
  - [Telematik Cheatsheet](Telematik1-cheatsheet.pdf)

Lernen ist viel Arbeit und bereitet dir Schwierigkeiten? Lies unsere [Hilfe](richtig%20lernen.md)

Keine Garantie auf Vollständigkeit/Korrektheit! Hilf uns Fehler zu korrigieren und noch weitere Fächer abzudecken.

## Verwendung
Alle Dokumente werden in (bevorzugt) Markdown  oder LaTex geschrieben. Bilder, Grafiken, Musik etc ist in einem eigenen Ordner "Assets". Bei Fragen zu Markdown könnt ihr Google befragen, Cheatsheets lesen (da steht meistens alles drauf) oder im Notfall den Admin fragen.
Dieses Repo ist zum Selbststudium und erlernen neuen Wissens gedacht. Kein Inhalte oder Teile dieses Repositories dürfen kommerziell verwendet werden. Es steht frei zu Teilen, Klonen und Mitzuarbeiten.
Wir freuen uns über jeden der mitmacht.

## Recht auf Kopie deiner Prüfungsleistung
Die TU Ilmenau ist sich ja selbst nicht sehr sicher wie sie damit umgeht und, wie so oft, verbietet es erstmal ganz. Nach bereits erfolgreichen Teilschritten hoffen wir bald wieder vollständig Einblick in unsere eigenen Leistungen nehmen zu können und tatsächlich aus unseren Fehlern lernen zu können. Falls du eine Kopie deiner Prüfung mit Aufgaben und Bemerkungen einholen willst, nutze gerne unsere Vorlage.

! Hinweis: Wir sind keine Juristen oder ähnliche Ausbildung. Der Antrag ist eine Sammlung verschiedener Gesetztestexte und Entscheidungen die in den letzten Jahren getroffen wurden. Hilf mit, dieses Dokument zu vervollständigen und schreib mich bei Problemen/Fragen an.

Hier gehts zum: [Antrag auf Kopie einer Prüfung](Antrag%20auf%20Kopie%20einer%20Prüfung.pdf)

## Mitmachen
Eine kleine Beschreibung für Leute die noch nie auf Github zusammengearbeitet haben. Vorraussetzung für diese Aktionen ist es, ein Github-Konto zu besitzen.
- Erstelle ein 'issue'. Gehe davor die offene 'issues' durch (oder überlege dir welches Fach/Seminar noch fehlt)
- Klone das Repository oder erstelle einen Fork. Über die Kommandozeile: ```git clone https://github.com/wieerwill/Informatik.git```
- Erstelle deinen eigenen Feature Branch, damit deine Version nicht mit anderen kollidiert: ```git checkout -b <my-new-feature>``` (in <> kannst du frei wählen wie du deinen Branch nennst)
- Nachdem du Änderungen vorgenommen hast, stelle deine Änderungen bereit: ```git add * && git commit -m <dein Kommentar>``` (in <> kommt dein Kommentar was sich geändert hat bzw woran du gearbeitet hast. Nicht der Dateiname!)
- Lade die Änderung auf deinen Branch hoch: ```git push origin <my-new-feature>```
- Erstelle ein 'pull request' damit deine Änderungen in diesem Repository übernommen werden können. Dies kannst du über dein Github Dashboard machen.

## Bild- und Textrechte
Der Inhalt aller vorhandenen Dokumente beruht auf den Mitschriften besuchter Vorlesungen. Bilder werden von uns selbst erstellt oder unter ausführlicher Quellangabe verwendet. Es werden keine Bücher kopiert oder anderweitig Copyright verletzt. Die Verletzung des Copyright oder anderer Rechte Dritter wird mit einem Ausschluss aus dem Repository gehandelt. Sollte Ihnen ein Verstoß auffallen, geben Sie uns bitte umgehend Bescheid, wir werden jedem Fall nachgehen.

## Lizenz
Dieses Repository und sein Inhalt sind unter der GNU GENERAL PUBLIC LICENSE Version 3 veröffentlicht. Was das bedeutet könnt ihr [hier](LICENSE) nachlesen.
